<template>
  <div class="popup-container d-flex flex-col" :class="{ closeable: canClose }"
    v-if="show" @click="onClicked" :id="`pc-${id}`"
  >
    <slot />
  </div>
</template>

<script>
export default {
  data: () => ({
    id: null,
  }),
  props: {
    show: {
      type: Boolean,
      default: false
    },
    canClose: {
      type: Boolean,
      default: true,
    },
  },
  methods: {
    onClicked(e) {
      if (!e.target || !this.$props.canClose) return ;
      if (e.target.id === `pc-${this.id}` ||
          e.target.classList.contains('popup-close')) {
        this.$emit('update:show', false);
      }
    },
  },
  mounted() {
    this.id = this._uid;
  },
};
</script>

<style scoped>
.popup-container {
  position: fixed;
  top: 0;
  left: 0;
  background: rgba(0, 0, 0, .8);
  width: 100%;
  max-height: 100%;
  height: 100%;
  overflow-y: auto;
  z-index: 999;
}

.popup-container::before,
.popup-container::after {
  flex: 0 0 2em;
  content: '';
}

.popup-container > * {
  margin: auto;
}

.popup-container:not(.closeable) button.popup-close {
  display: none;
}

@media only screen and (max-width: 550px) {
  .popup-container {
    padding: 0 !important;
  }

  .popup-container::before,
  .popup-container::after {
    flex: 0 0 0;
    content: '';
  }

  .popup-container > *:not(.nothing) {
    border-radius: 0;
    width: 100%;
  }
}
</style>
